/*---------------------------------------------------------------------*/
/* --- STC AI Limited -------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#include "stc.h"
#include "i2s.h"

BOOL WaveUpdate;                        //ݸ±־λ
BOOL WavePlayEn;                        //ʹ
BOOL WaveOverrun;                       //־λ
BOOL WaveUnderrun;                      //־λ
BYTE WaveMute;                          //ƼĴ
WORD WavePreSamp;                       //I2Sݻ
WORD WaveWritePtr;                      //лдָ
WORD WaveReadPtr;                       //лָ
WORD WaveDumpSize;                      //
WORD xdata WaveBuffer[BUFFER_SIZE];     //ݻ

u16	cnt_2ms = 0;
bit	B_2ms;

//====================== I2Sʼ ==================================================
#define	MCKOE		1		//I2Sʱ, 0:ֹI2Sʱ, 1:I2Sʱ

#define	I2SEN		0x04	//I2Sģʹ, 0x00:ֹ, 0x04:
#define	I2S_MODE	2		//I2Sģʽ, 0:ӻģʽ, 1:ӻģʽ, 2:ģʽ, 3:ģʽ,

#define	PCMSYNC		0		//PCM֡ͬ, 0: ֡ͬ, 1: ֡ͬ
#define	STD_MODE	0		//I2S׼ѡ, 0: I2Sֱ׼, 1: MSB׼, 2:LSBҶ׼, 3:PCM׼, CS4334CS4344ʹ0:I2Sֱ׼PT8211ʹ1: MSB׼
#define	CKPOL		0		//I2S̬ʱӼ, 0:ʱȶ״̬Ϊ͵ƽ, 1:ʱȶ״̬Ϊߵƽ
#define	DATLEN		0		//ݳ, 0:16λ, 1:24λ, 2:32λ, 3:
#define	CHLEN		0		//ͨ(ÿƵͨλ), 0:16λ, 1: 32λ

#define I2S_MCLKDIV		(FOSC/(8*16*2*SAMPFREQ))	//MCLKƵϵ, ˫16bit.
#define I2S_BCLKDIV		(FOSC/(16*2*SAMPFREQ))	//BCLKƵϵ, ˫16bit.

void i2s_init()
{
	I2SMD = 0xff;					//ڲֽ,ΪFFH
	I2SSR = 0x00;					//״̬Ĵ0
	I2SCR = 0x80+0x00;				//ʹܷͻж(0x80), +0x00:Motorolaʽ, +0x10:TIʽ
	HSCLKDIV   = 1;					//HSCLKDIVʱӷƵ
	I2S_CLKDIV = 1;					//I2SʱӷƵ
	I2SMCKDIV  = I2S_MCLKDIV;					//I2SʱӷƵI2SMCLK = Ƶ/2/I2S_CLKDIV/HSCLKDIV/I2SMCKDIV,  I2SMCLK = PLLCLK/2/I2S_CLKDIV/HSCLKDIV/I2SMCKDIV
	I2SPRH = (MCKOE << 1) + (I2S_BCLKDIV & 1);	//I2S_BMCLKƵϵbit0, ֹMCLK
	I2SPRL = I2S_BCLKDIV/2;						//I2S_BMCLKƵϵbit8~bit1
	I2SCFGH = I2S_MODE;				//I2SģʽΪģʽ
	I2SCFGL = (PCMSYNC << 7) + (STD_MODE << 4) + (CKPOL << 3) + (DATLEN << 1) + CHLEN;
//	P_SW3 = (P_SW3 & 0x3f) | (3<<6);	//I2S˿л, 0: P3.2(BCLK) P3.3(MCLK) P3.4(SD) P3.5(WS),	2024-6-18
	P_SW3 = (P_SW3 & 0x3f) | (1<<6);	//I2S˿л, 0: P3.2(BCLK) P3.3(MCLK) P3.4(SD) P3.5(WS),	2024-7-21
										//             1: P1.7(BCLK) P1.6(MCLK) P1.5(SD) P1.4(WS),
										//             2: P2.3(BCLK) P2.2(MCLK) P2.1(SD) P2.0(WS),
										//             3: P4.3(BCLK) P1.6(MCLK) P4.1(SD) P4.0(WS),
	I2SCFGH |= I2SEN;                   //ʹI2Sģ

	IP3  |= 0x08;	                    //I2SжΪȼ
	IP3H |= 0x08;

    WavePlayEn = 0;
    WaveMute = 1;
    WaveOverrun = 0;
    WaveUnderrun = 0;
    WavePreSamp = 0;
    WaveWritePtr = 0;
    WaveReadPtr = 0;
    WaveDumpSize = 0;
}

void i2s_isr(void) interrupt 62
{
    if (I2SSR & 0x02)	//ͻ
    {
        I2SDRH = WavePreSamp >> 8;      //׼,Զл
        I2SDRL = WavePreSamp;           //ע⣺I2SݼĴдֽڣдֽ

        if (WaveMute)
        {
            WavePreSamp = 0;            //ʱ,׼0
        }
        else
        {
            if (WavePlayEn)
            {
                if (WaveDumpSize)       //жǷ㹻
            	{
                    WavePreSamp = WaveBuffer[WaveReadPtr++];
                    WaveReadPtr &= BUFFER_MASK;
                    WaveDumpSize--;     //ǰжΪȼ,ҪٽWaveDumpSizeб
            	}
                else
                {
                    WaveUnderrun = 1;   //
                    WavePlayEn = 0;
                }
            }
        }
    }
    if(++cnt_2ms == (96*2))
    {
		cnt_2ms = 0;
		B_2ms = 1;
	}
}

